export class Main extends Indicator {

    constructor() {
        super();

        this.addInput("PriceType", InputType.PriceType, PriceType.Bid);

        this.buffers = {
            FractalsUp : this.addBuffer(),
            FractalsDown : this.addBuffer(),
        };
    }

    onInit() {
        this.buffers.FractalsUp
            .setShape(Shape.Arrow)
            .setArrow(ArrowSymbols.ArrowDoubleUpWards)
            .setAnchor(Anchor.Bottom)
            .setColor(Color.SeaGreen)
            .setWidth(1)
        ;

        this.buffers.FractalsDown
            .setShape(Shape.Arrow)
            .setArrow(ArrowSymbols.ArrowDoubleDownWards)
            .setAnchor(Anchor.Top)
            .setColor(Color.Red)
            .setWidth(1)
        ;
    }

    async onUpdate() {
        const {PriceType} = this.getInputs(),
                {FractalsUp, FractalsDown} = this.buffers;

        let buffers = await Indicators.Fractals(null, 0, PriceType);
        FractalsUp.fill(buffers[IndicatorLine.Upper]);
        FractalsDown.fill(buffers[IndicatorLine.Lower]);
    }
}